<template>
  <div class="app-container">
    <el-tree
      v-loading="listLoading"
      lazy
      :load="loadNode"
      :data="data"
      node-key="nodeid"
      element-loading-text="Loading"
      highlight-current-row
      :expand-on-click-node="true">
      <span class="custom-tree-node" slot-scope="{ node, data }">
        <span>
          <i v-if="data.nodetype === 1" class="el-icon-menu"></i>
          <i v-else class="el-icon-document"></i>
          <span style="margin-left: 10px">{{ data.nodepath }}</span>
        </span>
        <span>
          <el-button
            type="text"
            size="mini"
            @click.stop="() => changePermission(node, data)">
            修改权限
          </el-button>
          <el-button
            type="text"
            size="mini"
            @click.stop="() => removeNode(node, data)">
            删除
          </el-button>
        </span>
      </span>
    </el-tree>
    <PermissionManage ref="permDialog" :canAdd="true" :dialogData="this.dialogData" />
  </div>
</template>

<style>
  .custom-tree-node {
    flex: 1;
    display: flex;
    align-items: center;
    justify-content: space-between;
    font-size: 14px;
    padding-right: 8px;
  }
</style>

<script>
import PermissionManage from '@/components/PermissionManage'
import { list_tree } from '@/api/projmanage'

export default {
  filters: {
  },
  components: {
    PermissionManage
  },
  data() {
    return {
      data: null,
      listLoading: false,
      dialogData: {
          curUser: null,
          curNode: null
      }
    }
  },
  created() {

  },
  methods: {
    fetchData(pathid) {
      this.listLoading = true
      return list_tree(pathid).then(response => {
        this.listLoading = false
        return response.content
      })
    },
    openDialog() {
        this.$refs.permDialog.$emit('open')
    },
    loadNode(node, resolve) {
      if (!node.parent){
        resolve([{
          nodeid: null,
          nodepath: "/",
          nodetype: 1
        }])
      } else {
        this.fetchData(node.data.nodeid).then(response => {
          resolve(response)
        })
      }
    },
    changePermission(node, data) {
        this.dialogData.curUser = null
        if (data.nodeid === null) {
            this.dialogData.curNode = ""
        } else {
            this.dialogData.curNode = data.nodeid
        }
        this.openDialog()
    }
  }
}
</script>
